/'
   Render Support
'/

Sub RenderRectButton(dst As Any Ptr, Ctrl As _kGUI_Control Ptr)
Dim As Integer tx,ty,w,h,Offset,newclr,pushed,round
Dim As FB.Image Ptr FBimg
Dim As Any Ptr img

   With *Ctrl

      img = ._internal.img

      If (._internal.mouseover<>._internal.statechange) Or (img=0) Then

         ._internal.statechange = ._internal.mouseover

         round = 3
         If round <1 Then round=1
         If round >5 Then round=5
               
         If img Then
            ImageDestroy img
         End If
         
         img = ImageCreate(.dx+1,.dy+1,,32)
         ._internal.img = img

         'Draw Button
         pushed = .state
         If .sticky Then
            pushed = IIf(.value>0,1,0)   
         EndIf
         
         'Determing if button is transparent
         If .trans Then
            DrawRoundRectangle (img,0,0,.dx,.dy,&hFF00FF,round,1)
         Else
            DrawRoundRectangle (img,0,0,.dx,.dy,0,round,0)
         EndIf
         
         If pushed Then 
            DrawRoundRectangle (img,1,1,.dx-2,.dy-2,AddClr(.backcolor,32),round,1)
         Else
            DrawRoundRectangle (img,1,1,.dx-2,.dy-2,.backcolor,round,1)
            If ._internal.mouseover Then
               DrawRoundRectangle (img,1,1,.dx-2,.dy-2,&hFFFF00,round,0)
            End If
         End If
         
         'If button has picture, draw it
         If .picture Then
            Offset=IIf(.maskimage>0,0,2)
            ImageInfo .picture,w,h
            If .state Then
               Put img,(.dx/2-w/2+Offset,.dy/2-h/2+Offset),.picture,TRANS
            Else
               Put img,(.dx/2-w/2,.dy/2-h/2),.picture,TRANS
            End If
         EndIf
   
         'Calc text position
         Select Case .justify
            Case 0
               tx = 3
            Case 1
               tx = .dx - Len(.text)*8 - 3
            Case 2   
               tx = (.dx/2) - Len(.text)*4 + 2            
         End Select
   
         ty = (.dy/2) - 3   
                     
         Draw String img,(tx,ty),.text,.ForeColor
      
      End If
            
      Put dst,(.x,.y),img,TRANS
      
   End With
 
End Sub

Sub RenderMaskButton(dst As Any Ptr, Ctrl As _kGUI_Control Ptr)
Dim As Integer tx,ty,w,h,Offset,newclr,pushed
Dim As FB.Image Ptr FBimg
Dim As Any Ptr img = ctrl->_internal.img  
   
   With *Ctrl

      img = ._internal.img

      If (._internal.mouseover<>._internal.statechange) Or (img=0) Then

         ._internal.statechange = ._internal.mouseover
         
         FBimg = Cast(FB.Image Ptr, .maskimage)

         If img Then
            ImageDestroy img
         End If
         
         img = ImageCreate(FBimg->Width,FBimg->height,,32)
         ._internal.img = img
         
         'Determing if button is transparent
         If .trans Then   
            Line img,(0,0)-Step(.dx,.dy),.BackColor,B    
         End If

         'If button has picture, draw it
         If .picture Then
            ImageInfo .picture,w,h
            Put img,(.dx/2-w/2,.dy/2-h/2),.picture,TRANS
         EndIf

         'Calc text position
         Select Case .justify
            Case 0
               tx = 3
            Case 1
               tx = .dx - Len(.text)*8 - 3
            Case 2   
               tx = (.dx/2) - Len(.text)*4 + 2            
         End Select
   
         ty = (.dy/2) - 3
         tx -= .state
                        
         Draw String img,(tx,ty),.text,.ForeColor

         Put img,(0,0),.maskimage,Or
         Put img,(0,0),.maskimage,Xor
      
      End If
            
      Put dst,(.x,.y),img,CUSTOM,@CustomButton,Cast(Any Ptr,ctrl)
   
   End With
   
End Sub
